/*08 / 15 / 2006*/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License .
 */
/* Created by Dev-C++ 5 Beta version 4.9.9.2 */
/*codename:DR-P-1*/
/*Serial Number DataBase GUI Version Beta 0.4 for Windows.*/
#include <windows.h>
#include "resource.h"

LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK AboutDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK AddDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK SearchDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK EditDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK DeleteDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK LGPLDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK READMEDlgProc(HWND, UINT, WPARAM, LPARAM);

HWND hView;
HWND hMessage;
HWND hwnd,ppp;    

char szClassName[ ] = "SNDB-GUI";
int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,int nFunsterStil)
{
    MSG messages;            
    WNDCLASSEX wincl;        

    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      
    wincl.style = CS_DBLCLKS;                 
    wincl.cbSize = sizeof (WNDCLASSEX);
    wincl.hIcon = LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(ID_ICON));
    wincl.hIconSm = (HICON)LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(ID_ICON),IMAGE_ICON, 16, 16, 0);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = MAKEINTRESOURCE(ID_MENU);                
    wincl.cbClsExtra = 0;                      
    wincl.cbWndExtra = 0;                     
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;
    if (!RegisterClassEx (&wincl))
        return 0;

    hwnd = CreateWindowEx (
           0,                   
           szClassName,         
           "Serial Number DataBase (GUI Version Beta 0.4) for Windows.",
           WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX, 
           CW_USEDEFAULT,       
           CW_USEDEFAULT,       
           500,                 
           400,                 
           HWND_DESKTOP,        
           NULL,                
           hThisInstance,       
           NULL                 
           );
    
    ShowWindow (hwnd, nFunsterStil);
    UpdateWindow(hwnd);
    
    while (GetMessage (&messages, NULL, 0, 0))
    {
        TranslateMessage(&messages);
        DispatchMessage(&messages);
    }
    return messages.wParam;
}

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
 static HWND hwndButton=(0);
 static int cx, cy;
 static HINSTANCE hInstance;
 HDC hdc;
 	  
    switch (message)                  
    {
       case WM_CREATE:
       {
       TEXTMETRIC tm;
       hdc = GetDC (hwnd);
       SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT));
       int NButton_Width=65;
       int NButton_Length=35;
       creatnew();   
       
       /*Open Data file.*/
       static HANDLE hPreloader;
       hPreloader = CreateFile("sndb.dat",GENERIC_READ | GENERIC_WRITE,FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,
                                          OPEN_EXISTING,0,NULL);
       /*Define and create Data display.*/
       static HANDLE hHeap;
       DWORD dwRead ;
       DWORD dwFileSize;
   	   LPSTR szData;
       
       dwFileSize = GetFileSize(hPreloader, NULL);
       hHeap = HeapCreate(0,0,0);
       szData = HeapAlloc(hHeap,HEAP_ZERO_MEMORY, dwFileSize + 1);
       
       SetFilePointer(hPreloader,0,NULL,FILE_BEGIN);
       ReadFile(hPreloader,szData,dwFileSize,&dwRead,NULL);
       szData[dwFileSize] = 0;
                     
       hView = CreateWindowEx(WS_EX_CLIENTEDGE,"EDIT",szData, 
				WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_HSCROLL | ES_MULTILINE | ES_AUTOVSCROLL | ES_AUTOHSCROLL, 
				0,20,400,250, hwnd,(HMENU)0, GetModuleHandle(NULL), NULL);
				
       HeapFree(hHeap,0,szData);
       HeapDestroy(hHeap);
       CloseHandle(hPreloader);
       
       /*Create Message log.*/
       static HANDLE MessageLog;
       MessageLog = CreateFile("message.log",GENERIC_READ | GENERIC_WRITE,FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,
                                          OPEN_EXISTING,0,NULL);
       
       static HANDLE hHeap_2;
       DWORD dwRead_2 ;
       DWORD dwFileSize_2;
   	   LPSTR szMsg;

       dwFileSize_2 = GetFileSize(MessageLog, NULL);
       hHeap_2 = HeapCreate(0,0,0);
       szMsg = HeapAlloc(hHeap_2,HEAP_ZERO_MEMORY, dwFileSize_2 + 1);
       
       SetFilePointer(MessageLog,0,NULL,FILE_BEGIN);
       ReadFile(MessageLog,szMsg,dwFileSize_2,&dwRead_2,NULL);
       szMsg[dwFileSize_2] = 0;
                                   	
	   hMessage = CreateWindowEx(WS_EX_STATICEDGE,"EDIT",szMsg, 
				WS_CHILD | WS_VISIBLE | WS_VSCROLL | ES_MULTILINE | ES_AUTOVSCROLL , 
				0,290,490,50, hwnd,(HMENU)0, GetModuleHandle(NULL), NULL);
				
       HeapFree(hHeap_2,0,szMsg);
       HeapDestroy(hHeap_2);
	   CloseHandle(MessageLog);

       hwndButton = CreateWindow ("button","Add",
       WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
       425,10,NButton_Width,NButton_Length,hwnd,(HMENU)ID_SNDB_ADD,((LPCREATESTRUCT) lParam)->hInstance,NULL);
       
       hwndButton = CreateWindow ("button","Edit",
       WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
       425,50,NButton_Width,NButton_Length,hwnd,(HMENU)ID_SNDB_EDIT,((LPCREATESTRUCT) lParam)->hInstance,NULL);
       
       hwndButton = CreateWindow ("button","Delete",
       WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
       425,90,NButton_Width,NButton_Length,hwnd,(HMENU)ID_SNDB_DELETE,((LPCREATESTRUCT) lParam)->hInstance,NULL);
       
       hwndButton = CreateWindow ("button","Load",
       WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
       425,130,NButton_Width,NButton_Length,hwnd,(HMENU)ID_SNDB_LOAD,((LPCREATESTRUCT) lParam)->hInstance,NULL);
       
       hwndButton = CreateWindow ("button","Save As",
       WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
       425,170,NButton_Width,NButton_Length,hwnd,(HMENU)ID_SNDB_SAVE_AS,((LPCREATESTRUCT) lParam)->hInstance,NULL);
       
       hwndButton = CreateWindow ("button","Search",
       WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
       425,210,NButton_Width,NButton_Length,hwnd,(HMENU)ID_SNDB_SEARCH,((LPCREATESTRUCT) lParam)->hInstance,NULL);
       
       hwndButton = CreateWindow ("button","Exit",
       WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
       425,250,NButton_Width,NButton_Length,hwnd,(HMENU)ID_SNDB_EXIT,((LPCREATESTRUCT) lParam)->hInstance,NULL);
       
       return (0);
       break;
       }
       PAINTSTRUCT ps;
       RECT rect;
       case WM_PAINT:
            hdc = BeginPaint (hwnd,&ps);
            GetClientRect(hwnd,&rect);
            SetBkColor (hdc,GetSysColor (WHITE_BRUSH));
            TextOut (hdc,0,1,TEXT("DATA :"),6);
            TextOut (hdc,0,272.5,TEXT("MESSAGE :"),9);
            EndPaint (hwnd,&ps);
            return (0);
            
       case WM_COMMAND:
            
            switch (LOWORD (wParam))
            {
            case ID_SNDB_EXIT:
                 SendMessage (hwnd,WM_DESTROY,0,0);
            break;
            
            case ID_SNDB_ABOUT:
                 DialogBox(hInstance,TEXT("AboutBox"),hwnd,AboutDlgProc);
            break;
            
            case ID_SNDB_ADD:
                 DialogBox(hInstance,TEXT("AddBox"),hwnd,AddDlgProc);
            break;
            
            case ID_SNDB_SAVE_AS:
                 DoFileSave(hwnd);
            break;
            
            case ID_SNDB_LOAD:
                 backup();        
                 DoFileOpen(hwnd);
            break;
            
            case ID_SNDB_NEW:
                 sndbnew();
            break;
            
            case ID_SNDB_LGPL:
                 DialogBox(hInstance,TEXT("LGPLBox"),hwnd,LGPLDlgProc);
            break;
                       
            case ID_SNDB_SEARCH:
                 DialogBox(hInstance,TEXT("SearchBox"),hwnd,SearchDlgProc);
            break;
            
            case ID_SNDB_EDIT:
                 DialogBox(hInstance,TEXT("EditBox"),hwnd,EditDlgProc);
            break;
            
            case ID_SNDB_DELETE:
                 DialogBox(hInstance,TEXT("DeleteBox"),hwnd,DeleteDlgProc);
            break;
            
            case ID_SNDB_RECOVERY:
                 loadbackup();
            break;
            case ID_SNDB_README:
                 DialogBox(hInstance,TEXT("READMEBox"),hwnd,READMEDlgProc);
            break;
            case ID_SNDB_MANUAL:
                 manual();
            break;   
            
            case ID_SNDB_CHECK:
                 scan();
            break;
            }
            break;
            
       case WM_SYSCOLORCHANGE :
            InvalidateRect (hwnd,NULL,TRUE );
            break;   

       case WM_DESTROY:
             remove("message.log");
             remove("search.dat");
             remove("temp.dat");
             remove("delete.dat");
             remove("name.dat");
             remove("sn.dat"); 
             remove("format.dat");
             remove("temp_msg.log");
             remove("path.conf");
             remove("path2.conf");
             remove("manual.bat");
            PostQuitMessage (0);       
            break;
            
        default:                      
            return DefWindowProc (hwnd, message, wParam, lParam);
    }
 
}
